
package Intento1;


import com.jme.input.InputHandler;
import com.jme.input.KeyBindingManager;
import com.jme.input.KeyInput;

/**
 * Input Handler for the Flag Rush game. This controls a supplied spatial
 * allowing us to move it forward, backward and rotate it left and right.
 * @author Mark Powell
 *
 */
public class teclado extends InputHandler {

     //the vehicle we are going to control
    private moto vehicle;
    //the default action
    private AccionDerrape drift;

     public void update(float time) {
        if ( !isEnabled() ) return;

        super.update(time);
        //we always want to allow friction to control the drift
        drift.performAction(event);
        vehicle.update(time);
     }

    public teclado(moto vehicle, String api) {
        this.vehicle = vehicle;
        setKeyBindings(api);
        setActions(vehicle);

    }

    /**
     * setKeyBindings establece las teclas que permitiran manejar la moto. En este caso las flechas
     */
    private void setKeyBindings(String api) {

        KeyBindingManager keyboard = KeyBindingManager.getKeyBindingManager();
        keyboard.set("forward", KeyInput.KEY_UP);
        keyboard.set("backward", KeyInput.KEY_DOWN);
        keyboard.set("turnRight", KeyInput.KEY_RIGHT);
        keyboard.set("turnLeft", KeyInput.KEY_LEFT);
        
    }

    /**
     * setActions define los triggers para las teclas, para que hagan la accion que queremos cuando pulsamos.
     */

    private void setActions(moto node) {
      
        AvanzarRetroceder forward = new AvanzarRetroceder(node, AvanzarRetroceder.FORWARD);
        addAction(forward, "forward", true);
        AvanzarRetroceder backward = new AvanzarRetroceder(node, AvanzarRetroceder.BACKWARD);
        addAction(backward, "backward", true);
        RotacionMoto rotateLeft = new RotacionMoto(node, RotacionMoto.LEFT);
        addAction(rotateLeft, "turnLeft", true);
        RotacionMoto rotateRight = new RotacionMoto(node, RotacionMoto.RIGHT);
        addAction(rotateRight, "turnRight", true);

        drift = new AccionDerrape(node);
    }
}
